// EmonLibrary examples openenergymonitor.org, Licence GNU GPL V3
// sketch modified for use with SCT-013-050 CT by Bobby Balsa 
//SCT-013-050 has built-in burder resistor and generates 1V rms @50Ampères

#include "EmonLib.h"            // Include Emon Library
EnergyMonitor Pana_airco;      // Create an instance
String FeedBackT = "";
int searchFeedBack = 0;
double kiloWatth = 0;
unsigned long startMillis;
unsigned long stopMillis;
void setup()
{  
  Serial.begin(9600);
  
  Pana_airco.current(1, 50);  // A1 input pin, 50Amps generate 1Vrms (SCT-013-050)
  startMillis=millis();
}

void loop(){

  
  double Irms = Pana_airco.calcIrms(1480);  // Calculate Irms only
   if (Irms<0.55)   //Even when A1 is shorted to voltage divider Irms meas 0.55Amps or less
  Irms = 0;         //due to ADC 
  double Power =(Irms*230.0);
 // Serial.print(Irms*230.0);	       // Apparent power
 // Serial.print(" ");
 // Serial.println(Irms);	
  stopMillis=millis();
  unsigned long Elapsed =stopMillis-startMillis;
  kiloWatth=kiloWatth+(Power*((double)Elapsed/3600/1000000));
  startMillis=millis();
  String Evalue = (String)"kWh "+ kiloWatth + "\n";  //create strings for RoboRemo app
  String Ivalue = (String)"current " + Irms + "\n"; //format : "id + value + \n 
  String Pvalue = (String)"power " + Power + "\n";  // see RoboRemo https://www.roboremo.com/
  
  Serial.print(Ivalue); // send measured values to the RoboRemo app
  Serial.print(Pvalue);
  Serial.print(Evalue);
  //Serial.print("");               debug :-)
  //Serial.print(searchFeedBack);   debug :-)
  delay(1000);
  if (searchFeedBack == 7){  // if kWhreset is pressed reset kWhcounter 
    kiloWatth = 0;
    searchFeedBack = 0;
   }
 }
  
   
  


void serialEvent(){                 //called when kWhreset is pressed
  while (Serial.available()){
    char input=(char)Serial.read();
    FeedBackT+=input;
  }
    searchFeedBack = FeedBackT.indexOf('resetkWh'); // app sends "resetkWh" 
    FeedBackT = "";                //clear string
    
  }
